Subject: 24.3.50; c++-mode fontification for constructors is inconsistent
From: Ivan Andrus <[email-masked]>
To: [email-masked]
Date: Wed, 18 Sep 2013 20:44:39 -0600
List-Id: <debbugs-submit.debbugs.gnu.org>

Font locking of C++ constructors is somewhat inconsistent.  This is no
doubt complicated by the fact that unlike other function declarations
they "don't have a return type".

When a single argument is not used but named, the constructor is not
fontified (normally it's fontified with `font-lock-function-name-face').
If the keyword explicit is used, then the argument type is fontified as
a variable, and the constructor name is fontified as a type.  Perhaps
interestingly, naming the parameter or adding another parameter causes
fontification to work correctly (with or without explicit).

I have included a sample file below with comments on what I see in `emacs -q`

class Bob
{
    // string is `font-lock-type-face', Bob is `font-lock-function-name-face'
    Bob( string bob );
    // string and Bob are not fontified (though I sometimes see string fontified as a type)
    Bob( string );
    // string is `font-lock-variable-name-face', Bob is `font-lock-type-face'
    explicit Bob( string );
    // string is `font-lock-type-face', Bob is `font-lock-function-name-face'
    explicit Bob( string, string );
};

Thanks,
Ivan

In GNU Emacs 24.3.50.1 (i386-apple-darwin12.5.0, NS apple-appkit-1187.39)
of 2013-09-16 on ivanandres-MacBookPro
Bzr revision: 114309 [email-masked]
Windowing system distributor `Apple', version 10.3.1187
Configured using:
`configure --with-ns --with-xml2'

Important settings:
  locale-coding-system: nil
  default enable-multibyte-characters: t

Major mode: C++/lah

Minor modes in effect:
  diff-auto-refine-mode: t
  eldoc-mode: t
  highlight-parentheses-mode: t
  hl-sexp-mode: t
  highlight-symbol-mode: t
  which-function-mode: t
  show-paren-mode: t
  msb-mode: t
  minibuffer-depth-indicate-mode: t
  global-hl-line-mode: t
  delete-selection-mode: t
  auto-image-file-mode: t
  auto-insert-mode: t
  yas-global-mode: t
  yas-minor-mode: t
  shell-dirtrack-mode: t
  ido-everywhere: t
  global-visible-mark-mode: t
  visible-mark-mode: t
  gvol-mode: t
  recentf-mode: t
  desktop-save-mode: t
  drag-stuff-global-mode: t
  drag-stuff-mode: t
  tooltip-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t
  abbrev-mode: t